<?php
/**
 * Created by PhpStorm.
 * Script Name: Music.php
 * Create: 2022/4/18 10:38
 * Description: 音乐助手
 * Author: fudaoji<fdj@kuryun.cn>
 */

namespace app\bot\controller;

use ky\Ovooa;

class Music extends Addon
{
    private $switch;
    private $toWxid = '';
    public function init($options = [])
    {
        parent::init($options); // TODO: Change the autogenerated stub
        $this->switch = true;
        return $this;
    }

    /**
     * 机器人主动事件
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\ModelNotFoundException
     * @throws \think\exception\DbException
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function deviceCallbackHandle(){
        if(!empty($this->groupWxid)){
            $this->groupChatHandle();
        }
    }

    /**
     * 群聊处理器
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\ModelNotFoundException
     * @throws \think\exception\DbException
     */
    public function groupChatHandle(){
        if(empty($this->switch)){
            return false;
        }
        $this->toWxid = $this->groupWxid;
        //一、关键词
        $this->keyword();
    }

    /**
     * 私聊处理器
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function privateChatHandle(){
        if(empty($this->switch)){
            return false;
        }
        $this->toWxid = $this->fromWxid;
        //一、关键词
        $this->keyword();
    }

    /**
     * 关键词回复
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\ModelNotFoundException
     * @throws \think\exception\DbException
     * Author: fudaoji<fdj@kuryun.cn>
     */
    private function keyword(){
        $msg = trim($this->content['msg']);
        if(strpos($msg, "歌曲") === 0){
            $arr = explode('歌曲', $msg);
            if(empty($arr['1'])){
                return;
            }
            $music = Ovooa::getInstance()->migu([
                'msg' => $arr[1]
            ]);
            if(! $music['code']){
                $this->botClient->sendTextToFriends(['robot_wxid' => $this->content['robot_wxid'], 'to_wxid' => $this->toWxid, 'msg' => '未找到歌曲【'.$arr[1].'】']);
            }

            $this->botClient->sendShareLinkMsg([
                'robot_wxid' => $this->content['robot_wxid'],
                'to_wxid' => $this->toWxid,
                'title' => $music['data']['musicname'],
                'desc' => '歌手：' . $music['data']['singer'],
                'image_url' => $music['data']['image'],
                'url' => $music['data']['musicurl']
            ]);
        }
    }
}